#include <iostream>
#include <vector>

int main(void)
{

  std::vector<int> x; // On declare un vecteur (vide pour l'instant)
  

  if (x.empty()) // empty teste si le vecteur est vide.
	std::cout << "Le vecteur est vide.\n";
  else
	std::cout << "Le vecteur n'est pas vide.\n";


  // On ajoute des elements.
  x.push_back(1);
  x.push_back(2);
  x.push_back(3);
  x.push_back(4.5); // Les elements de x sont des int (car il a ete declare comme std::vector<int>). Par consequent, 4.5 et 5.1 sont convertis en 4 et 5.
  x.push_back(5.1);
  x.push_back(6);
  x.push_back(7);

  
  if (x.empty())
	std::cout << "Le vecteur est vide.\n";
  else
	std::cout << "Le vecteur n'est pas vide.\n";
  

  // size renvoie la taille.
  std::cout << "Taille du vecteur : " << x.size() << "\n";


  // On utilise un iterateur (sur vecteur) pour parcourir x.
  for (std::vector<int>::iterator it = x.begin(); it != x.end(); it++)
	std::cout << *it << " ";
  std::cout << "\n";

  std::cout << x[1] << " " << x[4] << "\n";

  // Ici un iterateur retrograde.
  for (std::vector<int>::reverse_iterator it = x.rbegin(); it != x.rend(); it++)
	std::cout << *it << " ";
  std::cout << "\n";


  
  x.pop_back();// Enleve le dernier element.
  for (std::vector<int>::iterator it = x.begin(); it != x.end(); it++)
	std::cout << *it << " ";
  std::cout << "\n";


  std::vector<int>::iterator it = x.begin();
  it ++;
  it ++;
  std::cout << "On va effacer l'element " << *it << "\n";
  x.erase(it); // On efface l'element en position it.

  
  for (std::vector<int>::iterator it = x.begin(); it != x.end(); it++)
	std::cout << *it << " ";
  std::cout << "\n";


  return 0;
}
